#include "fete.h"
#include <qlineedit.h>
#include <qapplication.h>
#include <qclipboard.h>
#include <qspinbox.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qdir.h>

Fete::Fete( QWidget* parent,  const char* name, WFlags fl )
    : FeteBase( parent, name, fl )
{
	text = QString();

	// եɤࡣ
	readSetting();

	// ɤ߹ˤꥵѹ
	sizeChange(fontSize);

	// ɤ߹ˤưߤϤޤʤʤ?
	move(x, y);

	// ٥ȥե륿ϿdeactivateĤޤ뤿ᡣ
	installEventFilter(this);

	connect(line, SIGNAL(returnPressed()), this, SLOT(returned()));
	connect(fontSelect, SIGNAL(valueChanged(int)), this, SLOT(sizeChange(int)));
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Fete::~Fete()
{
    // no need to delete child widgets, Qt does it all for us
}

bool Fete::eventFilter(QObject *o, QEvent *e)
{
	if (e->type() == QEvent::WindowDeactivate) {
		deactivated();
		return TRUE;
	}
	return QWidget::eventFilter(o, e);
}

// ϻΥϥɥ顣
// ߤΥƥȤtextappendLineEdit򥯥ꥢ
void Fete::returned()
{
	text.append(line->text()).append('\n');
	line->setText("");
}

// ɥhideȤΥϥɥ顣
// ޤǤϥƥȤ򥯥åץܡɤꡢȤΥƥȤϥꥢ
// ϤʤäˤϥåץܡɤƤݻ뤿ˤʤˤ⤷ʤ
void Fete::deactivated()
{
	QClipboard *cb = QApplication::clipboard();
	if (!line->text().isNull()) {
		text.append(line->text());
	}
	if (!text.isNull()) {
		cb->setText(text);
		line->setText("");
		text = QString();
	}

	// եȥѹѤSpinBoxƤǤ⡢
	// ̤ڤؤLineEdit˥ե᤹
	line->setFocus();
}

// եȥѹSpinBoxͤѤäȤΥϥɥ顣
// եȤΥѹɥΥĴ롣
void Fete::sizeChange(int n)
{
	QFont f = font();
	f.setPixelSize(n);
	setFont(f);

	// ñresizeȲڤؤ̤ˤʤäƤޤ
	setMaximumSize(width, sizeHint().height());
	setMinimumSize(width, sizeHint().height());
	fontSelect->setMaximumSize(n + 22, fontSelect->sizeHint().height());
}

// եɤ߹ߡ
void Fete::readSetting()
{
	// ǥեͤ͡ʤФѡ
	fontSize = 10;
	width = 240;
	x = 0; y = 0;

	QString home = QDir::homeDirPath();
	QFile rcfile(home + "/.feterc");
	if (!rcfile.open(IO_ReadOnly)) {
		return;
	}

	QTextStream st(&rcfile);
	QString line;
	QRegExp regFont("^font[ \t]*=[ \t]*");
	QRegExp regWidth("^width[ \t]*=[ \t]*");
	QRegExp regX("^x[ \t]*=[ \t]*");
	QRegExp regY("^y[ \t]*=[ \t]*");
	while (!st.eof()) {
		line = st.readLine();
		checkAndSet(regFont, line, fontSize);
		checkAndSet(regWidth, line, width);
		checkAndSet(regX, line, x);
		checkAndSet(regY, line, y);
	}
	rcfile.close();

	// ɤ߹եȥSpinBoxͤѹ
	fontSelect->setValue(fontSize);
}

void Fete::checkAndSet(QRegExp &reg, QString &line, int &v)
{
	int len, n;
	bool ok;
	if (!reg.match(line, 0, &len)) {
		n = line.mid(len, 10).toInt(&ok, 10);
		if (ok == TRUE) {
			v = n;
		}
	}
}
